/******************************************************************************
 * File     :  ex02.c
 * Purpose  :  Basic Pointers 2
 * Author   :  Prajin Palangsantikul
 * E-mail   :  prajin@appsofttech.com
 * Release  :  PCW Compiler 3.180
 * Copyright (c) 2004 APPSOFTTECH CO.,LTD.
 *****************************************************************************/

#define _PIC16F877_           // Use PIC16F877 device

#ifdef _PIC16F877_
#include <16F877.h>           // Standard Header file for the PIC16F877 device
#define  TxD         PIN_C6   // Define Transmitted Data
#define  RxD         PIN_C7   // Define Received Data
#define  CLOCK_SP    20000000 // Clock Speed(Hz)

#else
#include <16F628.h>           // Standard Header file for the PIC16F628 device
#define  TxD         PIN_A2   // Define Transmitted Data
#define  RxD         PIN_A3   // Define Received Data
#define  CLOCK_SP    4000000  // Clock Speed(Hz)

#endif

// Device Specification
#fuses HS                     // Oscillator mode HS
#fuses NOLVP, NOWDT           // No Low Voltage Program, No Watchdog timer
#fuses NOPROTECT              // Code no protection
#use delay (clock=CLOCK_SP)   // Use built-in function: delay_ms() & delay_us()
#use rs232(baud=9600, xmit=TxD,rcv=RxD) // Use serial I/O port (RS232)


/***********************************************************************
 * FUNCTION:    Main
 * DESCRIPTION: This is the main entry point for the program.
 * PARAMETERS:  nothing
 * RETURNED:    nothing
 ***********************************************************************/
void main(void) {

	char str[11] = "0123456789";
   int idat[5] = {1,2,3,4,5};
	char *cptr;
   int *iptr;
   int i;

	cptr = &str[0];	//  same is cptr = str;

   printf("str[0]    = %c\r\n",str[0]);
   printf("*cptr     = %c\r\n",*cptr);
   printf("*(cptr+3) = %c\r\n",*(cptr+3));
   printf("cptr[3]   = %c\r\n",cptr[3]);
   printf("\r\n\n");

   iptr = idat;
   for(i=0; i<5; i++) {
      printf("%d  ",*(iptr+i));
   }
   printf("\r\n\n");

   iptr = idat;
   for(i=0; i<5; i++) {
      printf("%d  ",iptr[i]);
   }
   printf("\r\n\n");

   iptr = idat;

   printf("i[0]      = %d\r\n",idat[0]);
   printf("*iptr     = %d\r\n",*iptr);
   printf("*(iptr+3) = %d\r\n",*(iptr+3));
   printf("iptr[3]   = %d\r\n",iptr[3]);

   puts("(*iptr)++");
   printf("(*iptr)++  = %d\r\n",(*iptr)++);
   printf("*iptr  = %d\r\n",*iptr);

   puts("*iptr++;");
   printf("*iptr++  = %d\r\n",*iptr++);
   printf("*iptr  = %d\r\n",*iptr);

   puts("iptr = iptr+3;");
   iptr = iptr+3;
   printf("iptr = iptr+3  = %d\r\n",*iptr);

   while(TRUE);
}
